#include <stdio.h>
#include "p80211.h"
#include "wlan.h"

char *dev;

int main(int argc,char *argv[])
{
    int fd;
    p80211_frame_t frame;

    if (argc == 1) dev="wlan0";
    else if (argc == 2) dev=argv[1];
    else {
	fprintf(stderr,"too many arguments: sample_dump <dev>\n");
	return 1;
    }

    fd=open_wlan(dev);
    if (fd<0) {
	fprintf(stderr,"Could open wlan device %s : %d\n",dev,fd);
	perror(0);
	return 1;
    }

    while (1) {
	frame=read_frame(fd);
	if (frame==0) printf("frame could not be read !!!\n");
	else {
	    fprint_frame(stdout,frame);
	    free_frame(frame);
	}
	printf("\n");
	fflush(stdout);
    }
    
    return 0;
}
