#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <time.h>
#include <sys/poll.h>
#include "p80211.h"
#include "wlan.h"

char dev[]="wlan0";

/* inject valid packets 
   2 arguments:
   [number of packets==1] [interval==0]*/
/* BTW, no you don't get my wep key */ 

int main(int argc,char *argv[])
{
    int fd=0;
    p80211_frame_t frame;
    p80211_header_t header;

    char smac[6] = {0x00,0x1b,0x4b,0x29,0x61,0xb1};
    char dmac[6] = {0xff,0x10,0x07,0x00,0x12,0x53};
    char bssid[6] = {0x00,0x03,0x1b,0xc2,0x45,0x33};

    char sdata[62]={
	0x06,0x00,0x00,0x00,0x75,0x41,0x37,0x5a,
	0x4b,0xbc,0x55,0x69,0x07,0x58,0x4c,0x03,
	0xf4,0xa7,0x69,0xbc,0xdf,0x46,0x27,0x4d,
	0xd0,0xb6,0xcc,0x7c,0x8b,0x8b,0x46,0x06,
	0x30,0x72,0x67,0x72,0x5d,0x49,0xe6,0x0a,
	0xfb,0x74,0xef,0x59,0x1c,0x24,0x0b,0x07,
	0x60,0xee,0x1b,0x87,0xf1,0x6f,0x3a,0x88,
	0x54,0x25,0x5a,0x90,0xb4,0x68};

    int cnt=1,delay=0;

    if (argc > 1) cnt = atoi(argv[1]);
    if (argc > 2) delay = 1000 * atoi(argv[2]);

    fd=open_wlan(dev);
    if (fd<0) {
        fprintf(stderr,"Could open wlan device %s : %d\n",dev,fd);
        perror(0);
        return 1;
    }

    p80211_header_init(header);
    p80211_set_type(header,DATA_FRAME);
    p80211_set_flag(header,toDS_f | wep_f,1);
    p80211_set_duration(header,10);
    p80211_set_fragnb(header,0);
    p80211_set_seqnb(header,0);
    if (p80211_set_mac(header,SA,smac)) return 2;
    if (p80211_set_mac(header,DA,dmac)) return 2;
    if (p80211_set_mac(header,BSSID,bssid)) return 2;
    
    frame=make_frame(header,sdata,62);
    
    for (; cnt>0; cnt--) {
	write_frame(fd,frame);
	if (delay >= 0) usleep(delay);
    }

    close(fd);
    return 0;
}
